"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;
var _react = _interopRequireWildcard(require("react"));
var _reactNative = require("react-native");
var _VisionSdkViewManager = require("./VisionSdkViewManager");
function _getRequireWildcardCache(e) { if ("function" != typeof WeakMap) return null; var r = new WeakMap(), t = new WeakMap(); return (_getRequireWildcardCache = function (e) { return e ? t : r; })(e); }
function _interopRequireWildcard(e, r) { if (!r && e && e.__esModule) return e; if (null === e || "object" != typeof e && "function" != typeof e) return { default: e }; var t = _getRequireWildcardCache(r); if (t && t.has(e)) return t.get(e); var n = { __proto__: null }, a = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var u in e) if ("default" !== u && Object.prototype.hasOwnProperty.call(e, u)) { var i = a ? Object.getOwnPropertyDescriptor(e, u) : null; i && (i.get || i.set) ? Object.defineProperty(n, u, i) : n[u] = e[u]; } return n.default = e, t && t.set(e, n), n; }
var ScanMode = /*#__PURE__*/function (ScanMode) {
  ScanMode["OCR"] = "ocr";
  ScanMode["BARCODE"] = "barcode";
  ScanMode["QRCODE"] = "qrcode";
  return ScanMode;
}(ScanMode || {});
const Camera = _ref => {
  let {
    children,
    refProp,
    reRender,
    delayTime = 100,
    showScanFrame = true,
    captureWithScanFrame = true,
    BarCodeScanHandler = _e => {},
    ImageCaptured = _e => {},
    OCRScanHandler = _e => {},
    OnDetectedHandler = _e => {},
    onError = _e => {}
  } = _ref;
  const defaultScanMode = ScanMode.BARCODE;
  const [mode, setMode] = (0, _react.useState)(defaultScanMode);
  const [token, setToken] = (0, _react.useState)('');
  const [apiKey, setApiKey] = (0, _react.useState)('');
  const [cameraCaptureMode, setCameraCaptureMode] = (0, _react.useState)('auto');
  const [environment, setEnvironment] = (0, _react.useState)('staging');
  const [locationId, setLocationId] = (0, _react.useState)('');
  const [options, setOptions] = (0, _react.useState)({
    match: {
      location: true,
      search: ['recipients']
    },
    postprocess: {
      require_unique_hash: false
    },
    transform: {
      tracker: 'inbound',
      use_existing_tracking_number: false
    }
  });
  const VisionSDKViewRef = (0, _react.useRef)(null);
  (0, _react.useImperativeHandle)(refProp, () => ({
    cameraCaptureHandler: () => {
      onPressCaptures();
    },
    stopRunningHandler: () => {
      onPressStopRunning();
    },
    startRunningHandler: () => {
      onPressStartRunning();
    },
    onPressToggleTorchHandler: val => {
      onPressToggleTorch(val);
    },
    setToDefaultZoom: val => {
      onPressZoom(val);
    },
    setMetadata: val => {
      setMetadata(val);
    },
    setHeight: val => {
      setHeight(val);
    },
    setRecipient: val => {
      setRecipient(val);
    },
    setSender: val => {
      setSender(val);
    },
    changeModeHandler: (c_mode, receivedInput, receivedToken, receivedLocationId, option, appEnvironment) => {
      setEnvironment(appEnvironment ? appEnvironment : environment);
      setToken(receivedToken);
      setLocationId(receivedLocationId);
      setApiKey(apiKey);
      onChangeCaptureMode(c_mode);
      onChangeMode(receivedInput);
      onChangeOptions(option ? option : options);
    }
  }));
  const onPressCaptures = () => {
    console.log('Image Captured');
    _reactNative.UIManager.dispatchViewManagerCommand((0, _reactNative.findNodeHandle)(VisionSDKViewRef.current), _reactNative.UIManager.hasViewManagerConfig('VisionSDKView') && _reactNative.UIManager.getViewManagerConfig('VisionSDKView').Commands.captureImage || 0, []);
  };
  const onPressStopRunning = () => {
    console.log('onPressStopRunning');
    _reactNative.UIManager.dispatchViewManagerCommand((0, _reactNative.findNodeHandle)(VisionSDKViewRef.current), _reactNative.UIManager.hasViewManagerConfig('VisionSDKView') && _reactNative.UIManager.getViewManagerConfig('VisionSDKView').Commands.stopRunning || 1, []);
  };
  const onPressStartRunning = () => {
    console.log('onPressStartRunning');
    _reactNative.UIManager.dispatchViewManagerCommand((0, _reactNative.findNodeHandle)(VisionSDKViewRef.current), _reactNative.UIManager.hasViewManagerConfig('VisionSDKView') && _reactNative.UIManager.getViewManagerConfig('VisionSDKView').Commands.startRunning || 2, []);
  };
  const onPressToggleTorch = value => {
    console.log('Toggle Torch', value);
    _reactNative.UIManager.dispatchViewManagerCommand((0, _reactNative.findNodeHandle)(VisionSDKViewRef.current), _reactNative.UIManager.hasViewManagerConfig('VisionSDKView') && _reactNative.UIManager.getViewManagerConfig('VisionSDKView').Commands.toggleTorch || 3, [value]);
  };
  const onPressZoom = value => {
    console.log('Zoom value', value);
    _reactNative.UIManager.dispatchViewManagerCommand((0, _reactNative.findNodeHandle)(VisionSDKViewRef.current), _reactNative.UIManager.hasViewManagerConfig('VisionSDKView') && _reactNative.UIManager.getViewManagerConfig('VisionSDKView').Commands.setZoomTo || 4, [value]);
  };
  const setHeight = value => {
    _reactNative.UIManager.dispatchViewManagerCommand((0, _reactNative.findNodeHandle)(VisionSDKViewRef.current), _reactNative.UIManager.hasViewManagerConfig('VisionSDKView') && _reactNative.UIManager.getViewManagerConfig('VisionSDKView').Commands.setHeight || 5, [value]);
  };
  const setMetadata = value => {
    _reactNative.UIManager.dispatchViewManagerCommand((0, _reactNative.findNodeHandle)(VisionSDKViewRef.current), _reactNative.UIManager.hasViewManagerConfig('VisionSDKView') && _reactNative.UIManager.getViewManagerConfig('VisionSDKView').Commands.setMetaData || 6, [value]);
  };
  const setRecipient = value => {
    _reactNative.UIManager.dispatchViewManagerCommand((0, _reactNative.findNodeHandle)(VisionSDKViewRef.current), _reactNative.UIManager.hasViewManagerConfig('VisionSDKView') && _reactNative.UIManager.getViewManagerConfig('VisionSDKView').Commands.setRecipient || 7, [value]);
  };
  const setSender = value => {
    _reactNative.UIManager.dispatchViewManagerCommand((0, _reactNative.findNodeHandle)(VisionSDKViewRef.current), _reactNative.UIManager.hasViewManagerConfig('VisionSDKView') && _reactNative.UIManager.getViewManagerConfig('VisionSDKView').Commands.setSender || 8, [value]);
  };
  const onChangeCaptureMode = c_mode => {
    setCameraCaptureMode(c_mode);
  };
  const onChangeMode = input => {
    setMode(input);
  };
  const onChangeOptions = input => {
    setOptions(input);
  };
  (0, _react.useEffect)(() => {
    _reactNative.DeviceEventEmitter.addListener('onBarcodeScanSuccess', BarCodeScanHandler);
    _reactNative.DeviceEventEmitter.addListener('onImageCaptured', ImageCaptured);
    _reactNative.DeviceEventEmitter.addListener('onOCRDataReceived', OCRScanHandler);
    _reactNative.DeviceEventEmitter.addListener('onDetected', OnDetectedHandler);
    return () => {
      _reactNative.DeviceEventEmitter.removeAllListeners('onBarcodeScanSuccess');
      _reactNative.DeviceEventEmitter.removeAllListeners('onOCRDataReceived');
      _reactNative.DeviceEventEmitter.removeAllListeners('onDetected');
      _reactNative.DeviceEventEmitter.removeAllListeners('onImageCaptured');
    };
    // eslint-disable-next-line react-hooks/exhaustive-deps
  }, []);
  return /*#__PURE__*/_react.default.createElement(_react.default.Fragment, null, /*#__PURE__*/_react.default.createElement(_VisionSdkViewManager.VisionSdkView, {
    key: reRender,
    style: styles.flex,
    showScanFrame: showScanFrame,
    captureWithScanFrame: captureWithScanFrame,
    onBarcodeScanSuccess: BarCodeScanHandler,
    onImageCaptured: ImageCaptured,
    onOCRDataReceived: OCRScanHandler,
    onDetected: OnDetectedHandler,
    mode: mode,
    captureMode: cameraCaptureMode,
    delayTime: delayTime ? delayTime : 100,
    onError: onError,
    token: token,
    locationId: locationId,
    options: JSON.stringify(options) // ideally this should be passed from variable, that is receiving data from ScannerContainer
    ,
    environment: environment,
    ref: VisionSDKViewRef
  }, children));
};
var _default = exports.default = Camera;
const styles = _reactNative.StyleSheet.create({
  flex: {
    flex: 1
  },
  row: {
    flexDirection: 'row',
    alignItems: 'center',
    justifyContent: 'space-between'
  },
  buttonText: {
    fontSize: 15,
    color: 'yellow'
  },
  unbuttonText: {
    fontSize: 15,
    color: 'white'
  },
  zoomBlock: {
    paddingHorizontal: 5,
    borderRadius: 30,
    height: 40,
    flexDirection: 'row',
    backgroundColor: '#00000050',
    justifyContent: 'space-between'
  },
  iconStyle: {
    width: 55,
    height: 55,
    bottom: 8
  },
  autoManualBlock: {
    borderRadius: 4,
    paddingHorizontal: 2,
    height: 40,
    alignItems: 'center',
    flexDirection: 'row',
    backgroundColor: 'grey',
    justifyContent: 'space-between'
  },
  autoManualButton: {
    backgroundColor: '#fff',
    width: 80,
    borderRadius: 4,
    height: 30,
    marginHorizontal: 4,
    paddingHorizontal: 10,
    alignItems: 'center',
    justifyContent: 'center'
  },
  unautoManualButton: {
    backgroundColor: 'grey',
    width: 80,
    borderRadius: 4,
    height: 30,
    marginHorizontal: 4,
    paddingHorizontal: 10,
    alignItems: 'center',
    justifyContent: 'center'
  },
  circle: {
    width: 30,
    height: 30,
    borderRadius: 40,
    marginVertical: 5,
    marginHorizontal: 5,
    backgroundColor: '#00000050'
  },
  childrenContainer: {
    paddingTop: 20,
    justifyContent: 'space-between',
    position: 'absolute',
    top: 0,
    left: 0,
    height: '100%',
    width: '100%'
  }
});
//# sourceMappingURL=index.js.map